import java.io.File
import java.nio.charset.Charset

import com.google.common.io.Files

import org.apache.spark._
import org.apache.spark.streaming._
import org.apache.spark.SparkConf

//export PATH=$PATH:/media/alfard/Cblex/sbt/bin



object Streamv3 {


def functionToCreateContext(): StreamingContext = {

	val sc = new SparkConf().setAppName("Streamv3")
  
	val ssc = new StreamingContext(sc, Seconds(20))

	val lines = ssc.textFileStream("hdfs://localhost:54310/")

	val v1 = lines.map( x => x.split(",",-1).map(_.trim))

	val v2 = v1.map(x=>(x(4).toString, x(10).toString, (x(11) match { case ""|null => "NaN" case s => s } ).toDouble,(x(14) match { case ""|null => "NaN" case s => s } ).toDouble,(x(15) match { case ""|null => "NaN" case s => s } ).toDouble,x(6).toString,x(7).toString))

	val v3 = v2.filter{ k => k._4 > 48.903296 && k._4 < 48.924444 && k._5 > 2.331250 && k._5 < 2.385399 && k._3 < 15000}

//Altitude minimmum
	val v4 = v3.map{ case(a,b,c,d,e,f,g) => (a,c)}.reduceByKey((k,v) => Math.min(k,v))
//Creation key, value datanode
	val v3b = v3.map{ case (a,b,c,d,e,f,g) => (a,(b,c,d,e,f,g))}

	val v5 = v4.leftOuterJoin(v3b)

	val v6 = v5.filter{ case (k,(z,Some((b,c,d,e,f,g)))) => { z == c }}

	val v8 = v2.map{ case(a,b,c,d,e,f,g) => (a,b)}.transform (k => k.distinct.filter{ case (a,b) => b != ""})

	val v9 = v6.leftOuterJoin(v8)

	val v10 = v9.map{case (k,((z,Some((a,b,c,d,e,f))),Some(g))) => (k,g,b,c,d,e,f)}

	val output = v10.print()

	ssc.checkpoint("hdfs://localhost:54310/checkpoint")

	ssc
}



def main(args: Array[String]) {

val context = StreamingContext.getOrCreate("hdfs://localhost:54310/checkpoint", functionToCreateContext _)

// Start the context
context.start()
context.awaitTermination()

}
}